diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/socket_parser.c olsrd-current/src/socket_parser.c
--- olsrd-0.5.0/src/socket_parser.c	2005-05-29 14:47:45.000000000 +0200
+++ olsrd-current/src/socket_parser.c	2007-05-09 01:43:17.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: socket_parser.c,v 1.23 2005/05/29 12:47:45 br1 Exp $
+ * $Id: socket_parser.c,v 1.27 2007/05/08 23:43:17 bernd67 Exp $
  */
 
 #include <unistd.h>
@@ -60,9 +60,6 @@
 
 static int hfd = 0;
 
-static struct timeval tvp = {0, 0};
-static fd_set ibits;
-
 /**
  * Add a socket and handler to the socketset
  * beeing used in the main select(2) loop
@@ -81,7 +78,7 @@
       fprintf(stderr, "Bogus socket entry - not registering...\n");
       return;
     }
-  OLSR_PRINTF(2, "Adding OLSR socket entry %d\n", fd)
+  OLSR_PRINTF(2, "Adding OLSR socket entry %d\n", fd);
 
   new_entry = olsr_malloc(sizeof(struct olsr_socket_entry), "Socket entry");
 
@@ -114,7 +111,7 @@
       olsr_syslog(OLSR_LOG_ERR, "Bogus socket entry - not processing...\n");
       return 0;
     }
-  OLSR_PRINTF(1, "Removing OLSR socket entry %d\n", fd)
+  OLSR_PRINTF(1, "Removing OLSR socket entry %d\n", fd);
 
   entry = olsr_socket_entries;
   prev_entry = NULL;
@@ -157,11 +154,15 @@
 
 
 void
-poll_sockets()
+poll_sockets(void)
 {
   int n;
   struct olsr_socket_entry *olsr_sockets;
-  static struct tms tms_buf;
+  /* Global buffer for times(2) calls. Do not remopve since at least OpenBSD needs it. */
+  struct tms tms_buf;
+  fd_set ibits;
+  struct timeval tvp = {0, 0};
+
 
   /* If there are no registered sockets we
    * do not call select(2)
@@ -172,11 +173,10 @@
   FD_ZERO(&ibits);
   
   /* Adding file-descriptors to FD set */
-  olsr_sockets = olsr_socket_entries;
-  while(olsr_sockets)
+  
+  for(olsr_sockets = olsr_socket_entries; olsr_sockets; olsr_sockets = olsr_sockets->next)
     {
-      FD_SET(olsr_sockets->fd, &ibits);
-      olsr_sockets = olsr_sockets->next;
+      FD_SET((unsigned int)olsr_sockets->fd, &ibits); /* And we cast here since we get a warning on Win32 */    
     }
       
   /* Runnig select on the FD set */
@@ -187,27 +187,22 @@
   /* Did somethig go wrong? */
   if (n < 0) 
     {
-      if(errno == EINTR)
-	return;
-
-      olsr_syslog(OLSR_LOG_ERR, "select: %m");
-      OLSR_PRINTF(1, "Error select: %s", strerror(errno))
+      if(errno != EINTR) {
+        const char * const err_msg = strerror(errno);
+        olsr_syslog(OLSR_LOG_ERR, "select: %s", err_msg);
+        OLSR_PRINTF(1, "Error select: %s", err_msg);
+      }
       return;
     }
 
   /* Update time since this is much used by the parsing functions */
-  gettimeofday(&now, NULL);      
+  gettimeofday(&now, NULL);
   now_times = times(&tms_buf);
 
-  olsr_sockets = olsr_socket_entries;
-  while(olsr_sockets)
+  for(olsr_sockets = olsr_socket_entries;olsr_sockets;olsr_sockets = olsr_sockets->next)
     {
       if(FD_ISSET(olsr_sockets->fd, &ibits))
-	{
 	  olsr_sockets->process_function(olsr_sockets->fd);
-	}
-      olsr_sockets = olsr_sockets->next;
-    }
-  	
+    }  	
 }
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/tc_set.c olsrd-current/src/tc_set.c
--- olsrd-0.5.0/src/tc_set.c	2006-01-07 09:16:20.000000000 +0100
+++ olsrd-current/src/tc_set.c	2007-04-26 00:08:17.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: tc_set.c,v 1.24 2006/01/07 08:16:20 kattemat Exp $
+ * $Id: tc_set.c,v 1.26 2007/04/25 22:08:17 bernd67 Exp $
  */
 
 
@@ -55,11 +55,10 @@
  */
 
 int
-olsr_init_tc()
+olsr_init_tc(void)
 {
   int index;
- 
-  OLSR_PRINTF(5, "TC: init topo\n")
+  OLSR_PRINTF(5, "TC: init topo\n");
 
   olsr_register_timeout_function(&olsr_time_out_tc_set);
 
@@ -86,7 +85,7 @@
 olsr_tc_delete_entry_if_empty(struct tc_entry *entry)
 {
 
-  //OLSR_PRINTF(1, "TC: del entry if empty\n")
+  //OLSR_PRINTF(1, "TC: del entry if empty\n");
 
   if(entry->destinations.next == &entry->destinations)
     {
@@ -94,7 +93,7 @@
       DEQUEUE_ELEM(entry);
       //entry->prev->next = entry->next;
       //entry->next->prev = entry->prev;
-      OLSR_PRINTF(1, "TC-SET: Deleting empty entry %s ->\n", olsr_ip_to_string(&entry->T_last_addr))
+      OLSR_PRINTF(1, "TC-SET: Deleting empty entry %s ->\n", olsr_ip_to_string(&entry->T_last_addr));
       free(entry);
       return 1;
     }
@@ -118,7 +117,7 @@
   struct tc_entry *entries;
   olsr_u32_t hash;
 
-  //OLSR_PRINTF(1, "TC: lookup entry\n")
+  //OLSR_PRINTF(1, "TC: lookup entry\n");
 
   hash = olsr_hashing(adr);
 
@@ -149,7 +148,7 @@
   struct tc_entry *new_entry;
   olsr_u32_t hash;
 
-  OLSR_PRINTF(1, "TC: adding entry %s\n", olsr_ip_to_string(adr))
+  OLSR_PRINTF(1, "TC: adding entry %s\n", olsr_ip_to_string(adr));
 
   hash = olsr_hashing(adr);
 
@@ -189,7 +188,7 @@
   struct topo_dst *tmp_dsts, *dst_to_del;
   int retval;
 
-  //OLSR_PRINTF(5, "TC: deleting MPRS\n")
+  //OLSR_PRINTF(5, "TC: deleting MPRS\n");
 
   tmp_dsts = entry->destinations.next;
   retval = 0;
@@ -235,7 +234,7 @@
   struct topo_dst *new_topo_dst, *existing_dst;
   int retval;
 
-  //OLSR_PRINTF(1, "TC: update MPRS\n")
+  //OLSR_PRINTF(1, "TC: update MPRS\n");
 
   retval = 0;
 
@@ -305,7 +304,7 @@
                     retval = 1;
 
                   else
-                    OLSR_PRINTF(3, "Skipping Dijkstra (4)\n")
+                    OLSR_PRINTF(3, "Skipping Dijkstra (4)\n");
                 }
 
               saved_lq = existing_dst->saved_inverse_link_quality;
@@ -326,7 +325,7 @@
                     retval = 1;
 
                   else
-                    OLSR_PRINTF(3, "Skipping Dijkstra (5)\n")
+                    OLSR_PRINTF(3, "Skipping Dijkstra (5)\n");
                 }
             }
 	}
@@ -352,7 +351,7 @@
 {
   struct topo_dst *dsts;
   
-  //OLSR_PRINTF(1, "TC: lookup dst\n")
+  //OLSR_PRINTF(1, "TC: lookup dst\n");
 
   for(dsts = entry->destinations.next; 
       dsts != &entry->destinations; 
@@ -364,11 +363,6 @@
   return NULL;
 }
 
-
-
-
-
-
 /**
  * Time out entries
  *
@@ -376,28 +370,27 @@
  */
 
 void
-olsr_time_out_tc_set()
+olsr_time_out_tc_set(void)
 {
-  int index, deleted;
-  struct tc_entry *entry, *entry2;
-  struct topo_dst *dst_entry, *dst_to_delete;
-
+  int index;
 
   for(index=0;index<HASHSIZE;index++)
     {
       /* For all TC entries */
-      entry = tc_table[index].next;
+      struct tc_entry *entry = tc_table[index].next;
       while(entry != &tc_table[index])
 	{
+          struct tc_entry *entry2;
 	  //printf("INDEX: %d\n", index);
 	  /* For all destination entries of that TC entry */
-	  deleted = 0;
-	  dst_entry = entry->destinations.next;
+	  int deleted = 0;
+	  struct topo_dst *dst_entry = entry->destinations.next;
 	  while(dst_entry != &entry->destinations)
 	    {
 	      /* If timed out - delete */
 	      if(TIMED_OUT(dst_entry->T_time))
 		{
+                  struct topo_dst *dst_to_delete;
 		  deleted = 1;
 		  /* Dequeue */
 		  DEQUEUE_ELEM(dst_entry);
@@ -420,8 +413,6 @@
 	    olsr_tc_delete_entry_if_empty(entry2);
 	}
     }
-
-  return;
 }
 
 
@@ -429,11 +420,9 @@
  *Print the topology table to stdout
  */
 int
-olsr_print_tc_table()
+olsr_print_tc_table(void)
 {
   int i;
-  struct tc_entry *entry;
-  struct topo_dst *dst_entry;
   char *fstr;
   float etx;
   
@@ -441,49 +430,39 @@
               nowtm->tm_hour,
               nowtm->tm_min,
               nowtm->tm_sec,
-              (int)now.tv_usec / 10000)
+              (int)now.tv_usec / 10000);
 
   if (olsr_cnf->ip_version == AF_INET)
-  {
-    OLSR_PRINTF(1, "Source IP addr   Dest IP addr     LQ     ILQ    ETX\n")
-    fstr = "%-15s  %-15s  %5.3f  %5.3f  %.2f\n";
-  }
-
+    {
+      OLSR_PRINTF(1, "Source IP addr   Dest IP addr     LQ     ILQ    ETX\n");
+      fstr = "%-15s  %-15s  %5.3f  %5.3f  %.2f\n";
+    }
   else
-  {
-    OLSR_PRINTF(1, "Source IP addr                Dest IP addr                    LQ     ILQ    ETX\n")
-    fstr = "%-30s%-30s  %5.3f  %5.3f  %.2f\n";
-  }
+    {
+      OLSR_PRINTF(1, "Source IP addr                Dest IP addr                    LQ     ILQ    ETX\n");
+      fstr = "%-30s%-30s  %5.3f  %5.3f  %.2f\n";
+    }
 
   for (i = 0; i < HASHSIZE; i++)
-  {
-    entry = tc_table[i].next;
-
-    while (entry != &tc_table[i])
     {
-      dst_entry = entry->destinations.next;
-
-      while(dst_entry != &entry->destinations)
-      {
-        if (dst_entry->link_quality < MIN_LINK_QUALITY ||
-            dst_entry->inverse_link_quality < MIN_LINK_QUALITY)
-          etx = 0.0;
-
-        else
-          etx = 1.0 / (dst_entry->link_quality *
-                       dst_entry->inverse_link_quality);
-
-        OLSR_PRINTF(1, fstr, olsr_ip_to_string(&entry->T_last_addr),
-                    olsr_ip_to_string(&dst_entry->T_dest_addr),
-                    dst_entry->link_quality, dst_entry->inverse_link_quality,
-                    etx)
-
-        dst_entry = dst_entry->next;
-      }
-
-      entry = entry->next;
+      struct tc_entry *entry;
+      for(entry = tc_table[i].next;entry != &tc_table[i];entry = entry->next)
+        {
+          struct topo_dst *dst_entry;
+          for(dst_entry = entry->destinations.next;dst_entry != &entry->destinations;dst_entry = dst_entry->next)
+            {
+              if (dst_entry->link_quality < MIN_LINK_QUALITY ||
+                  dst_entry->inverse_link_quality < MIN_LINK_QUALITY)
+                etx = 0.0;
+              else
+                etx = 1.0 / (dst_entry->link_quality * dst_entry->inverse_link_quality);
+
+              OLSR_PRINTF(1, fstr, olsr_ip_to_string(&entry->T_last_addr),
+                          olsr_ip_to_string(&dst_entry->T_dest_addr),
+                          dst_entry->link_quality, dst_entry->inverse_link_quality,
+                          etx);
+            }
+        }
     }
-  }
-
   return 1;
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/two_hop_neighbor_table.c olsrd-current/src/two_hop_neighbor_table.c
--- olsrd-0.5.0/src/two_hop_neighbor_table.c	2005-05-29 14:47:46.000000000 +0200
+++ olsrd-current/src/two_hop_neighbor_table.c	2007-04-26 00:08:17.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: two_hop_neighbor_table.c,v 1.16 2005/05/29 12:47:46 br1 Exp $
+ * $Id: two_hop_neighbor_table.c,v 1.18 2007/04/25 22:08:17 bernd67 Exp $
  */
 
 
@@ -54,7 +54,7 @@
  *Initialize 2 hop neighbor table
  */
 int
-olsr_init_two_hop_table()
+olsr_init_two_hop_table(void)
 {
   int index;
 
@@ -242,7 +242,7 @@
  *@return nada
  */
 void
-olsr_print_two_hop_neighbor_table()
+olsr_print_two_hop_neighbor_table(void)
 {
   int i;
 
@@ -250,9 +250,9 @@
               nowtm->tm_hour,
               nowtm->tm_min,
               nowtm->tm_sec,
-              (int)now.tv_usec)
+              (int)now.tv_usec);
 
-  OLSR_PRINTF(1, "IP addr (2-hop)  IP addr (1-hop)  TLQ\n")
+  OLSR_PRINTF(1, "IP addr (2-hop)  IP addr (1-hop)  TLQ\n");
 
   for (i = 0; i < HASHSIZE; i++)
     {
@@ -272,18 +272,18 @@
               if (first)
                 {
                   OLSR_PRINTF(1, "%-15s  ",
-                              olsr_ip_to_string(&neigh2->neighbor_2_addr))
+                              olsr_ip_to_string(&neigh2->neighbor_2_addr));
                   first = OLSR_FALSE;
                 }
 
               else
-                OLSR_PRINTF(1, "                 ")
+                OLSR_PRINTF(1, "                 ");
 
               total_lq = entry->path_link_quality;
 
               OLSR_PRINTF(1, "%-15s  %5.3f\n",
                           olsr_ip_to_string(&neigh->neighbor_main_addr),
-                          total_lq)
+                          total_lq);
             }
 	}
     }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/unix/ifnet.c olsrd-current/src/unix/ifnet.c
--- olsrd-0.5.0/src/unix/ifnet.c	2007-03-14 15:01:14.000000000 +0100
+++ olsrd-current/src/unix/ifnet.c	2007-05-14 00:23:55.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: ifnet.c,v 1.46 2007/03/14 14:01:14 bernd67 Exp $
+ * $Id: ifnet.c,v 1.49 2007/05/13 22:23:55 bernd67 Exp $
  */
 
 
@@ -72,7 +72,7 @@
 
 
 int
-set_flag(char *ifname, short flag)
+set_flag(char *ifname, short flag __attribute__((unused)))
 {
   struct ifreq ifr;
 
@@ -108,12 +108,12 @@
 
 
 void
-check_interface_updates(void *foo)
+check_interface_updates(void *foo __attribute__((unused)))
 {
   struct olsr_if *tmp_if;
 
 #ifdef DEBUG
-  OLSR_PRINTF(3, "Checking for updates in the interface set\n")
+  OLSR_PRINTF(3, "Checking for updates in the interface set\n");
 #endif
 
   for(tmp_if = olsr_cnf->interfaces; tmp_if != NULL; tmp_if = tmp_if->next)
@@ -163,7 +163,7 @@
   if_changes = 0;
 
 #ifdef DEBUG
-  OLSR_PRINTF(3, "Checking if %s is set down or changed\n", iface->name)
+  OLSR_PRINTF(3, "Checking if %s is set down or changed\n", iface->name);
 #endif
 
   if(iface->host_emul)
@@ -185,7 +185,7 @@
   /* Get flags (and check if interface exists) */
   if (ioctl(olsr_cnf->ioctl_s, SIOCGIFFLAGS, &ifr) < 0) 
     {
-      OLSR_PRINTF(3, "No such interface: %s\n", iface->name)
+      OLSR_PRINTF(3, "No such interface: %s\n", iface->name);
       goto remove_interface;
     }
 
@@ -197,7 +197,7 @@
 
   if ((ifp->int_flags & IFF_UP) == 0)
     {
-      OLSR_PRINTF(1, "\tInterface %s not up - removing it...\n", iface->name)
+      OLSR_PRINTF(1, "\tInterface %s not up - removing it...\n", iface->name);
       goto remove_interface;
     }
 
@@ -212,13 +212,13 @@
       !iface->cnf->ipv4_broadcast.v4 && /* Skip if fixed bcast */ 
       (!(ifp->int_flags & IFF_BROADCAST))) 
     {
-      OLSR_PRINTF(3, "\tNo broadcast - removing\n")
+      OLSR_PRINTF(3, "\tNo broadcast - removing\n");
       goto remove_interface;
     }
 
   if (ifp->int_flags & IFF_LOOPBACK)
     {
-      OLSR_PRINTF(3, "\tThis is a loopback interface - removing it...\n")
+      OLSR_PRINTF(3, "\tThis is a loopback interface - removing it...\n");
       goto remove_interface;
     }
 
@@ -265,23 +265,23 @@
       if(get_ipv6_address(ifr.ifr_name, &tmp_saddr6, iface->cnf->ipv6_addrtype) <= 0)
 	{
 	  if(iface->cnf->ipv6_addrtype == IPV6_ADDR_SITELOCAL)
-	    OLSR_PRINTF(3, "\tCould not find site-local IPv6 address for %s\n", ifr.ifr_name)
+	    OLSR_PRINTF(3, "\tCould not find site-local IPv6 address for %s\n", ifr.ifr_name);
 	  else
-	    OLSR_PRINTF(3, "\tCould not find global IPv6 address for %s\n", ifr.ifr_name)
+	    OLSR_PRINTF(3, "\tCould not find global IPv6 address for %s\n", ifr.ifr_name);
 	  
 	  
 	  goto remove_interface;
 	}
       
 #ifdef DEBUG
-      OLSR_PRINTF(3, "\tAddress: %s\n", ip6_to_string(&tmp_saddr6.sin6_addr))
+      OLSR_PRINTF(3, "\tAddress: %s\n", ip6_to_string(&tmp_saddr6.sin6_addr));
 #endif
 
       if(memcmp(&tmp_saddr6.sin6_addr, &ifp->int6_addr.sin6_addr, olsr_cnf->ipsize) != 0)
 	{
-	  OLSR_PRINTF(1, "New IP address for %s:\n", ifr.ifr_name)
-	  OLSR_PRINTF(1, "\tOld: %s\n", ip6_to_string(&ifp->int6_addr.sin6_addr))
-	  OLSR_PRINTF(1, "\tNew: %s\n", ip6_to_string(&tmp_saddr6.sin6_addr))
+	  OLSR_PRINTF(1, "New IP address for %s:\n", ifr.ifr_name);
+	  OLSR_PRINTF(1, "\tOld: %s\n", ip6_to_string(&ifp->int6_addr.sin6_addr));
+	  OLSR_PRINTF(1, "\tNew: %s\n", ip6_to_string(&tmp_saddr6.sin6_addr));
 
 	  /* Check main addr */
 	  if(memcmp(&olsr_cnf->main_addr, &tmp_saddr6.sin6_addr, olsr_cnf->ipsize) == 0)
@@ -307,12 +307,12 @@
       /* Check interface address (IPv4)*/
       if(ioctl(olsr_cnf->ioctl_s, SIOCGIFADDR, &ifr) < 0) 
 	{
-	  OLSR_PRINTF(1, "\tCould not get address of interface - removing it\n")
+	  OLSR_PRINTF(1, "\tCould not get address of interface - removing it\n");
 	  goto remove_interface;
 	}
 
 #ifdef DEBUG
-      OLSR_PRINTF(3, "\tAddress:%s\n", sockaddr_to_string(&ifr.ifr_addr))
+      OLSR_PRINTF(3, "\tAddress:%s\n", sockaddr_to_string(&ifr.ifr_addr));
 #endif
 
       if(memcmp(&((struct sockaddr_in *)&ifp->int_addr)->sin_addr.s_addr,
@@ -320,9 +320,9 @@
 		olsr_cnf->ipsize) != 0)
 	{
 	  /* New address */
-	  OLSR_PRINTF(1, "IPv4 address changed for %s\n", ifr.ifr_name)
-	  OLSR_PRINTF(1, "\tOld:%s\n", sockaddr_to_string(&ifp->int_addr))
-	  OLSR_PRINTF(1, "\tNew:%s\n", sockaddr_to_string(&ifr.ifr_addr))
+	  OLSR_PRINTF(1, "IPv4 address changed for %s\n", ifr.ifr_name);
+	  OLSR_PRINTF(1, "\tOld:%s\n", sockaddr_to_string(&ifp->int_addr));
+	  OLSR_PRINTF(1, "\tNew:%s\n", sockaddr_to_string(&ifr.ifr_addr));
 
 	  ifp->int_addr = ifr.ifr_addr;
 
@@ -330,7 +330,7 @@
 		    &ifp->ip_addr,
 		    olsr_cnf->ipsize) == 0)
 	    {
-	      OLSR_PRINTF(1, "New main address: %s\n", sockaddr_to_string(&ifr.ifr_addr))
+	      OLSR_PRINTF(1, "New main address: %s\n", sockaddr_to_string(&ifr.ifr_addr));
 	      olsr_syslog(OLSR_LOG_INFO, "New main address: %s\n", sockaddr_to_string(&ifr.ifr_addr));
 	      memcpy(&olsr_cnf->main_addr, 
 		     &((struct sockaddr_in *)&ifr.ifr_addr)->sin_addr.s_addr, 
@@ -352,7 +352,7 @@
 	}
 
 #ifdef DEBUG
-      OLSR_PRINTF(3, "\tNetmask:%s\n", sockaddr_to_string(&ifr.ifr_netmask))
+      OLSR_PRINTF(3, "\tNetmask:%s\n", sockaddr_to_string(&ifr.ifr_netmask));
 #endif
 
       if(memcmp(&((struct sockaddr_in *)&ifp->int_netmask)->sin_addr.s_addr,
@@ -360,9 +360,9 @@
 		olsr_cnf->ipsize) != 0)
 	{
 	  /* New address */
-	  OLSR_PRINTF(1, "IPv4 netmask changed for %s\n", ifr.ifr_name)
-	  OLSR_PRINTF(1, "\tOld:%s\n", sockaddr_to_string(&ifp->int_netmask))
-	  OLSR_PRINTF(1, "\tNew:%s\n", sockaddr_to_string(&ifr.ifr_netmask))
+	  OLSR_PRINTF(1, "IPv4 netmask changed for %s\n", ifr.ifr_name);
+	  OLSR_PRINTF(1, "\tOld:%s\n", sockaddr_to_string(&ifp->int_netmask));
+	  OLSR_PRINTF(1, "\tNew:%s\n", sockaddr_to_string(&ifr.ifr_netmask));
 
 	  ifp->int_netmask = ifr.ifr_netmask;
 
@@ -379,7 +379,7 @@
 	    }
 	  
 #ifdef DEBUG
-	  OLSR_PRINTF(3, "\tBroadcast address:%s\n", sockaddr_to_string(&ifr.ifr_broadaddr))
+	  OLSR_PRINTF(3, "\tBroadcast address:%s\n", sockaddr_to_string(&ifr.ifr_broadaddr));
 #endif
 	  
 	  if(memcmp(&((struct sockaddr_in *)&ifp->int_broadaddr)->sin_addr.s_addr,
@@ -388,9 +388,9 @@
 	    {
 	      
 	      /* New address */
-	      OLSR_PRINTF(1, "IPv4 broadcast changed for %s\n", ifr.ifr_name)
-	      OLSR_PRINTF(1, "\tOld:%s\n", sockaddr_to_string(&ifp->int_broadaddr))
-	      OLSR_PRINTF(1, "\tNew:%s\n", sockaddr_to_string(&ifr.ifr_broadaddr))
+	      OLSR_PRINTF(1, "IPv4 broadcast changed for %s\n", ifr.ifr_name);
+	      OLSR_PRINTF(1, "\tOld:%s\n", sockaddr_to_string(&ifp->int_broadaddr));
+	      OLSR_PRINTF(1, "\tNew:%s\n", sockaddr_to_string(&ifr.ifr_broadaddr));
 	      
 	      ifp->int_broadaddr = ifr.ifr_broadaddr;
 	      if_changes = 1;
@@ -405,7 +405,7 @@
 
 
  remove_interface:
-  OLSR_PRINTF(1, "Removing interface %s\n", iface->name)
+  OLSR_PRINTF(1, "Removing interface %s\n", iface->name);
   olsr_syslog(OLSR_LOG_INFO, "Removing interface %s\n", iface->name);
 
   del_if_link_entries(&ifp->ip_addr);
@@ -441,12 +441,12 @@
 	{
 	  /* No more interfaces */
 	  memset(&olsr_cnf->main_addr, 0, olsr_cnf->ipsize);
-	  OLSR_PRINTF(1, "No more interfaces...\n")
+	  OLSR_PRINTF(1, "No more interfaces...\n");
 	}
       else
 	{
 	  COPY_IP(&olsr_cnf->main_addr, &ifnet->ip_addr);
-	  OLSR_PRINTF(1, "New main address: %s\n", olsr_ip_to_string(&olsr_cnf->main_addr))
+	  OLSR_PRINTF(1, "New main address: %s\n", olsr_ip_to_string(&olsr_cnf->main_addr));
 	  olsr_syslog(OLSR_LOG_INFO, "New main address: %s\n", olsr_ip_to_string(&olsr_cnf->main_addr));
 	}
     }
@@ -509,7 +509,7 @@
 
   if((ifnet == NULL) && (!olsr_cnf->allow_no_interfaces))
     {
-      OLSR_PRINTF(1, "No more active interfaces - exiting.\n")
+      OLSR_PRINTF(1, "No more active interfaces - exiting.\n");
       olsr_syslog(OLSR_LOG_INFO, "No more active interfaces - exiting.\n");
       olsr_cnf->exit_value = EXIT_FAILURE;
       kill(getpid(), SIGINT);
@@ -546,12 +546,10 @@
 
   strcpy(ifp->int_name, "hcif01");
 
-  OLSR_PRINTF(1, "Adding %s(host emulation):\n", ifp->int_name)
+  OLSR_PRINTF(1, "Adding %s(host emulation):\n", ifp->int_name);
 
   OLSR_PRINTF(1, "       Address:%s\n", olsr_ip_to_string(&iface->hemu_ip));
 
-  OLSR_PRINTF(1, "       Index:%d\n", iface->index);
-
   OLSR_PRINTF(1, "       NB! This is a emulated interface\n       that does not exist in the kernel!\n");
 
   ifp->int_next = ifnet;
@@ -561,13 +559,10 @@
   if(COMP_IP(&null_addr, &olsr_cnf->main_addr))
     {
       COPY_IP(&olsr_cnf->main_addr, &iface->hemu_ip);
-      OLSR_PRINTF(1, "New main address: %s\n", olsr_ip_to_string(&olsr_cnf->main_addr))
+      OLSR_PRINTF(1, "New main address: %s\n", olsr_ip_to_string(&olsr_cnf->main_addr));
 	olsr_syslog(OLSR_LOG_INFO, "New main address: %s\n", olsr_ip_to_string(&olsr_cnf->main_addr));
     }
 
-  /* setting the interfaces number*/
-  ifp->if_nr = iface->index;
-
   ifp->int_mtu = OLSR_DEFAULT_MTU;
 
   ifp->int_mtu -= (olsr_cnf->ip_version == AF_INET6) ? UDP_IPV6_HDRSIZE : UDP_IPV4_HDRSIZE;
@@ -745,12 +740,12 @@
   memset(&ifr, 0, sizeof(struct ifreq));
   strncpy(ifr.ifr_name, iface->name, IFNAMSIZ);
 
-  OLSR_PRINTF(debuglvl, "Checking %s:\n", ifr.ifr_name)
+  OLSR_PRINTF(debuglvl, "Checking %s:\n", ifr.ifr_name);
 
   /* Get flags (and check if interface exists) */
   if (ioctl(olsr_cnf->ioctl_s, SIOCGIFFLAGS, &ifr) < 0) 
     {
-      OLSR_PRINTF(debuglvl, "\tNo such interface!\n")
+      OLSR_PRINTF(debuglvl, "\tNo such interface!\n");
       return 0;
     }
 
@@ -760,7 +755,7 @@
 
   if ((ifs.int_flags & IFF_UP) == 0)
     {
-      OLSR_PRINTF(debuglvl, "\tInterface not up - skipping it...\n")
+      OLSR_PRINTF(debuglvl, "\tInterface not up - skipping it...\n");
       return 0;
     }
 
@@ -769,14 +764,14 @@
       !iface->cnf->ipv4_broadcast.v4 && /* Skip if fixed bcast */ 
       (!(ifs.int_flags & IFF_BROADCAST))) 
     {
-      OLSR_PRINTF(debuglvl, "\tNo broadcast - skipping\n")
+      OLSR_PRINTF(debuglvl, "\tNo broadcast - skipping\n");
       return 0;
     }
 
 
   if (ifs.int_flags & IFF_LOOPBACK)
     {
-      OLSR_PRINTF(debuglvl, "\tThis is a loopback interface - skipping it...\n")
+      OLSR_PRINTF(debuglvl, "\tThis is a loopback interface - skipping it...\n");
       return 0;
     }
 
@@ -786,9 +781,9 @@
   ifs.is_wireless = check_wireless_interface(ifr.ifr_name);
 
   if(ifs.is_wireless)
-    OLSR_PRINTF(debuglvl, "\tWireless interface detected\n")
+    OLSR_PRINTF(debuglvl, "\tWireless interface detected\n");
   else
-    OLSR_PRINTF(debuglvl, "\tNot a wireless interface\n")
+    OLSR_PRINTF(debuglvl, "\tNot a wireless interface\n");
 
   
   /* IP version 6 */
@@ -799,14 +794,14 @@
       if(get_ipv6_address(ifr.ifr_name, &ifs.int6_addr, iface->cnf->ipv6_addrtype) <= 0)
 	{
 	  if(iface->cnf->ipv6_addrtype == IPV6_ADDR_SITELOCAL)
-	    OLSR_PRINTF(debuglvl, "\tCould not find site-local IPv6 address for %s\n", ifr.ifr_name)
+	    OLSR_PRINTF(debuglvl, "\tCould not find site-local IPv6 address for %s\n", ifr.ifr_name);
 	  else
-	    OLSR_PRINTF(debuglvl, "\tCould not find global IPv6 address for %s\n", ifr.ifr_name)
+	    OLSR_PRINTF(debuglvl, "\tCould not find global IPv6 address for %s\n", ifr.ifr_name);
 	  
 	  return 0;
 	}
       
-      OLSR_PRINTF(debuglvl, "\tAddress: %s\n", ip6_to_string(&ifs.int6_addr.sin6_addr))
+      OLSR_PRINTF(debuglvl, "\tAddress: %s\n", ip6_to_string(&ifs.int6_addr.sin6_addr));
       
       /* Multicast */
       ifs.int6_multaddr.sin6_addr = (iface->cnf->ipv6_addrtype == IPV6_ADDR_SITELOCAL) ? 
@@ -821,7 +816,7 @@
       ifs.int6_multaddr.sin6_scope_id = 0;
 #endif
 
-      OLSR_PRINTF(debuglvl, "\tMulticast: %s\n", ip6_to_string(&ifs.int6_multaddr.sin6_addr))
+      OLSR_PRINTF(debuglvl, "\tMulticast: %s\n", ip6_to_string(&ifs.int6_multaddr.sin6_addr));
       
     }
   /* IP version 4 */
@@ -830,7 +825,7 @@
       /* Get interface address (IPv4)*/
       if(ioctl(olsr_cnf->ioctl_s, SIOCGIFADDR, &ifr) < 0) 
 	{
-	  OLSR_PRINTF(debuglvl, "\tCould not get address of interface - skipping it\n")
+	  OLSR_PRINTF(debuglvl, "\tCould not get address of interface - skipping it\n");
 	  return 0;
 	}
       
@@ -885,11 +880,7 @@
     ifs.int_metric = iface->cnf->weight.value;
   else
     ifs.int_metric = calculate_if_metric(ifr.ifr_name);
-  OLSR_PRINTF(1, "\tMetric: %d\n", ifs.int_metric)
-
-  /* setting the interfaces number*/
-  ifs.if_nr = iface->index;
-
+  OLSR_PRINTF(1, "\tMetric: %d\n", ifs.int_metric);
 
   /* Get MTU */
   if (ioctl(olsr_cnf->ioctl_s, SIOCGIFMTU, &ifr) < 0)
@@ -904,21 +895,21 @@
   /* Set up buffer */
   net_add_buffer(&ifs);
 	       
-  OLSR_PRINTF(1, "\tMTU - IPhdr: %d\n", ifs.int_mtu)
+  OLSR_PRINTF(1, "\tMTU - IPhdr: %d\n", ifs.int_mtu);
 
   olsr_syslog(OLSR_LOG_INFO, "Adding interface %s\n", iface->name);
-  OLSR_PRINTF(1, "\tIndex %d\n", ifs.if_nr)
+  OLSR_PRINTF(1, "\tIndex %d\n", ifs.if_index);
 
   if(olsr_cnf->ip_version == AF_INET)
     {
-      OLSR_PRINTF(1, "\tAddress:%s\n", sockaddr_to_string(&ifs.int_addr))
-      OLSR_PRINTF(1, "\tNetmask:%s\n", sockaddr_to_string(&ifs.int_netmask))
-      OLSR_PRINTF(1, "\tBroadcast address:%s\n", sockaddr_to_string(&ifs.int_broadaddr))
+      OLSR_PRINTF(1, "\tAddress:%s\n", sockaddr_to_string(&ifs.int_addr));
+      OLSR_PRINTF(1, "\tNetmask:%s\n", sockaddr_to_string(&ifs.int_netmask));
+      OLSR_PRINTF(1, "\tBroadcast address:%s\n", sockaddr_to_string(&ifs.int_broadaddr));
     }
   else
     {
-      OLSR_PRINTF(1, "\tAddress: %s\n", ip6_to_string(&ifs.int6_addr.sin6_addr))
-      OLSR_PRINTF(1, "\tMulticast: %s\n", ip6_to_string(&ifs.int6_multaddr.sin6_addr))
+      OLSR_PRINTF(1, "\tAddress: %s\n", ip6_to_string(&ifs.int6_addr.sin6_addr));
+      OLSR_PRINTF(1, "\tMulticast: %s\n", ip6_to_string(&ifs.int6_multaddr.sin6_addr));
     }
   
   ifp = olsr_malloc(sizeof (struct interface), "Interface update 2");
@@ -1015,7 +1006,7 @@
   if(COMP_IP(&null_addr, &olsr_cnf->main_addr))
     {
       COPY_IP(&olsr_cnf->main_addr, &ifp->ip_addr);
-      OLSR_PRINTF(1, "New main address: %s\n", olsr_ip_to_string(&olsr_cnf->main_addr))
+      OLSR_PRINTF(1, "New main address: %s\n", olsr_ip_to_string(&olsr_cnf->main_addr));
       olsr_syslog(OLSR_LOG_INFO, "New main address: %s\n", olsr_ip_to_string(&olsr_cnf->main_addr));
     }
   
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/win32/apm.c olsrd-current/src/win32/apm.c
--- olsrd-0.5.0/src/win32/apm.c	2005-03-21 03:17:36.000000000 +0100
+++ olsrd-current/src/win32/apm.c	2007-04-26 00:19:00.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: apm.c,v 1.10 2005/03/21 02:17:36 tlopatic Exp $
+ * $Id: apm.c,v 1.12 2007/04/25 22:19:00 bernd67 Exp $
  */
 
 #include "apm.h"
@@ -48,11 +48,11 @@
 #include <windows.h>
 #undef interface
 
-int apm_init()
+int apm_init(void)
 {
   struct olsr_apm_info ApmInfo;
 
-  OLSR_PRINTF(3, "Initializing APM\n")
+  OLSR_PRINTF(3, "Initializing APM\n");
 
   if(apm_read(&ApmInfo) < 0)
     return -1;
@@ -66,7 +66,7 @@
 {
   OLSR_PRINTF(5, "APM info:\n\tAC status %d\n\tBattery percentage %d%%\n\n",
 	      ApmInfo->ac_line_status,
-	      ApmInfo->battery_percentage)
+	      ApmInfo->battery_percentage);
 }
 
 int apm_read(struct olsr_apm_info *ApmInfo)
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/win32/arpa/inet.h olsrd-current/src/win32/arpa/inet.h
--- olsrd-0.5.0/src/win32/arpa/inet.h	2004-11-21 02:21:10.000000000 +0100
+++ olsrd-current/src/win32/arpa/inet.h	2007-05-09 01:18:56.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: inet.h,v 1.6 2004/11/21 01:21:10 tlopatic Exp $
+ * $Id: inet.h,v 1.7 2007/05/08 23:18:56 bernd67 Exp $
  */
 
 #if !defined TL_ARPA_INET_H_INCLUDED
@@ -49,7 +49,7 @@
 #undef interface
 
 int inet_aton(char *cp, struct in_addr *addr);
-int inet_pton(int af, char *src, void *dst);
-char *inet_ntop(int af, void *src, char *dst, int size);
+int inet_pton(int af, const char *src, void *dst);
+char *inet_ntop(int af, const void *src, char *dst, int size);
 
 #endif
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/win32/compat.c olsrd-current/src/win32/compat.c
--- olsrd-0.5.0/src/win32/compat.c	2005-03-21 03:17:36.000000000 +0100
+++ olsrd-current/src/win32/compat.c	2007-05-09 02:30:04.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: compat.c,v 1.12 2005/03/21 02:17:36 tlopatic Exp $
+ * $Id: compat.c,v 1.15 2007/05/09 00:30:04 bernd67 Exp $
  */
 
 /*
@@ -100,7 +100,7 @@
   return 0;
 }
 
-void gettimeofday(struct timeval *TVal, void *TZone)
+void gettimeofday(struct timeval *TVal, void *TZone __attribute__((unused)))
 {
   SYSTEMTIME SysTime;
   FILETIME FileTime;
@@ -118,7 +118,7 @@
   TVal->tv_usec = (unsigned int)(Ticks % 10000000) / 10;
 }
 
-long times(struct tms *Dummy)
+long times(struct tms *Dummy __attribute__((unused)))
 {
   return (long)GetTickCount();
 }
@@ -165,7 +165,7 @@
 
 // XXX - not thread-safe, which is okay for our purposes
  
-void *dlopen(char *Name, int Flags)
+void *dlopen(char *Name, int Flags __attribute__((unused)))
 {
 #if !defined WINCE
   return (void *)LoadLibrary(Name);
@@ -363,7 +363,7 @@
   return (1);
 }
 
-int inet_pton(int af, char *src, void *dst)
+int inet_pton(int af, const char *src, void *dst)
 {
   switch (af)
   {
@@ -477,7 +477,7 @@
   return strcpy(dst, tmp);
 }
 
-char *inet_ntop(int af, void *src, char *dst, int size)
+char *inet_ntop(int af, const void *src, char *dst, int size)
 {
   switch (af)
   {
@@ -522,3 +522,19 @@
   return 0;
 #endif
 }
+
+#define CHUNK_SIZE 512
+
+/* and we emulate a real write(2) syscall using send() */
+ssize_t write(int fd, const void *buf, size_t count)
+{
+  size_t written = 0;
+  while (written < count) {
+    ssize_t rc = send(fd, buf+written, min(count-written, CHUNK_SIZE), 0);
+    if (rc <= 0) {
+      break;
+    }
+    written += rc;
+  }
+  return written;
+}
